



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>oracle 数据库中的序列</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">oracle 数据库中的序列</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-25 07:24:48 </span>
						</div>
										<div class="post-content">
											
		<p>　序列是什么，通俗点说，序列就是按照一定顺序进行排列，序列会自动给你递增，生成唯一的序列号；</p>
<p>oracle数据库不同于sqlServer数据库，oracle数据库中是没有自增长列，使用的是sequence序列；</p>
<p>==== 创建序列</p>
<p>create &nbsp;sequence &nbsp;emp_sequence &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; -- &nbsp; &nbsp;(序列名)</p>
<p>increment &nbsp; &nbsp; by &nbsp;1 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;-- &nbsp;（每次增长的数）</p>
<p>start with &nbsp;1 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; -- &nbsp; &nbsp;(开始值)</p>
<p>nomaxvalue &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;-- &nbsp; &nbsp; (没有上限值)</p>
<p>nocycle &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; -- &nbsp; &nbsp; (不循环，递增)</p>
<p>nocache &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;-- &nbsp; (缓存)</p>
<p>==== 如何使用序列 (一般用于在主键列或者是唯一的自增列)</p>
<p>--创建表</p>
<pre class="prettyprint linenums">       create table user ( userId  number(10)    primary key, userName  varchar2(30))</pre>
<pre class="prettyprint linenums">   --在表使用序列</pre>
<pre class="prettyprint linenums">        insert  into  user (userId, userName) values(emp_sequence.nextval, "张三" )</pre>
<pre class="prettyprint linenums"> ====1、需要注意的一般常使用nocache 这可以防止出现跳号的情况，cache 10  使用会将10个序列号存储在缓存中，这样会提高效率，如果出现异常情况（断电或断网等等）</pre>
<pre class="prettyprint linenums">会出现跳号的现象；2、在使用currval 前需要先初始化（先执行nextval）</pre>
<pre class="prettyprint linenums">例如：&nbsp;select emp_sequence.nextval form dual;  --- 第一次返回的初始化的序列号</pre>
<pre class="prettyprint linenums">select  emp_sequence.currval form dual;   ---  查询当前的序列</pre>																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qn15dx8.html">基于英特尔&amp;&num;174&semi; 至强&trade; 处理器 E5 产品家族的多节点分布式内存系统上的 Caffe&ast; 培训</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pjgg49.html">Centos7安装PHP7</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw5y6yq.html">wampserver 2&period;5多站点配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx4moj9.html">php的一些小细节</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zrdn09.html">MODBUS-寄存器与功能码学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e10xrx9.html">Java 包装类中的静态函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnlnnoq.html">HDU Sky数 2097</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1jyox9.html">SQL优化 csdn</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0o34lq.html">SQL server概述</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x4mdz8.html">WPF实现毛玻璃效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzrm2l8.html">将Word表格中单元格中的文字替换成对应的图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdrrr79.html">MarkDown里面的Emoji表情</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj343j8.html">Docker：Docker 性质及版本选择 &lbrack;三&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd5o7e9.html">20172310 2017-2018-2 《程序设计与数据结构》实验三报告（敏捷开发与XP实践）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r41p48.html">动态从数据库获取数据，省市县三级联动，有校验，导出Excel模板</a>
		</li>
						<li><a href="https://www.batexi.com/a/960gog49.html">Java并发（六）线程池监控</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv06e28.html">CentOS7 安装 Jenkins</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv32ol8.html">【Social listening实操】从社交媒体传播和文本挖掘角度解读《欢乐颂2》</a>
		</li>
						<li><a href="https://www.batexi.com/a/953x2oz8.html">单页面vue引入百度统计的使用方法！</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1kxzx9.html">js中函数传参的情况</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q7z0g4e9.html">Quart&period;Net分布式任务管理平台</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yg3ow8.html">open-falcon Agent配置文件修改hostname后，还是有其他名称的endpoint</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd27vd9.html">树莓派链接WiFi设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv133zzq.html">mysql启动时报错：Starting MySQL&period;&period;&period; ERROR&excl; The server quit without updating PID file &lpar;&sol;opt&sol;mysql&sol;data&sol;mysql&period;pid&rpar; 的解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdprr3jq.html">C&num;设计模式之十二享元模式（Flyweight）【结构型】</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj40wj8.html">Robotframework自动化系统：筛选结果数量统计</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z3wl39.html">stack 的入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zoe22nq.html">canvas图表&lpar;1&rpar; - 柱状图</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgkl2e8.html">&lbrack;转载&rsqb;  Java NIO与IO</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kprgn39.html">转-Gitorious搭建步骤</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
